
/* ================================================================== */
/*		TWX MIDI server for P1+P2 March 1993                  */
/* ================================================================== */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <bios.h>
#include <dir.h>
#include <conio.h>
#include <ctype.h>
#include <time.h>
#include <io.h>

#include "mpu401.h"

#define TK_Q		100

int putcmd(int n);
int putcmd2(int n);
int getdata(void);
int getdat2(void);
int putdata(int n);
int putdat2(int n);

int net_boot (char *bootf,int link,int iskip,int quiet);

int TheLink=0x150;
int booting;
int record,player;
int nEv;
char Fn[MAXPATH];

long HostPar[16];

FILE *ftmp1,*ftmp2,*ftmp3,*fmpu;

char ebuf[4096];

/* ================================================================== */


int resetl(int link)
{
 int ctrl;

  ctrl=(link==0x240? 0x260:link+0x10);
  outportb(ctrl+1,0);
  outportb(ctrl,0);
  outportb(ctrl+3,0x80);
  outportb(ctrl,1);
  delay(200);
  outportb(ctrl,0);
  outportb(ctrl+3,0);
  outportb(link+2,0);
  outportb(link+3,0);
  return((inportb(link+2)==0)&&(inportb(link+3)==1));
}


void sendhpar(void)
{
 char *p;
 int i;

  delay(rand()%100);
  p = (char *)HostPar;
  for (i=0; i<64; i++) {
    while ((inportb(TheLink+3)&1)==0);
    outportb(TheLink+1,*p++);
   }
}


/* ================================================================== */


int get401(int mpu)
{
 int i;

  while (1) {
    if (kbhit()) return(-1);
    i = (mpu? getdat2(): getdata());
    if (i != -1) return(i);
   }
}


void putdata401(int mpu,int n)
{
  if (mpu) putdat2(n); else putdata(n);
}


void sxcmd(int mpu,int c)
{
 static char Cb[] = { 0xf0,0x18,0x04,0x00 };
 int i;

  for (i=0; i<4; i++) putdata401(mpu,Cb[i]);
  putdata401(mpu,c);
}


void eox(int mpu)
{
  putdata401(mpu,0xf7);
}


int sendcmd401(int mpu,int n)
{
 int ans;

  ans = (mpu? putcmd2(n):putcmd(n));
  if (ans == ACK) return(ans);
   else if (ans != -1) {
     /* ungetnext401(ans);      put pending data on stack */
     while (1) {              /* check for more incoming data */
       ans = (mpu? getdat2():getdata());
       if (ans == ACK || ans == -1) return(ans);
	/* else ungetnext401(ans); */
      }
    }
  return(ans);
}


int repeat_cmd401(int mpu,int n)
{
 int i, j, m;

  for (i = 0; i < 10; i++){
    m = sendcmd401(mpu,n);
    if (m != -1) return(m);
     else {
       for (j = 0; j < 10; j++) {
	 if (mpu) getdat2(); else getdata();
	}
      }
   }
  return(-1);
}


void all_notes_off(int mpu)
{
 int i;

  sendcmd401(mpu,RESET);
  delay(10);

  repeat_cmd401(mpu,UART);
  for(i = 0; i < 16; i++){
    putdata401(mpu,MODE_MESSAGE | i);
    putdata401(mpu,0x7f);
    putdata401(mpu,0);
    putdata401(mpu,MODE_MESSAGE | i);
    putdata401(mpu,0x79);
    putdata401(mpu,0);
    putdata401(mpu,MODE_MESSAGE | i);
    putdata401(mpu,ALL_NOTES_OFF);
    putdata401(mpu,0);
    delay(10);
   }
  sendcmd401(mpu,RESET);
}


/* ================================================================== */


void fiwrite(FILE *fd,void *k)
{
 char *p = (char *)k;

  fputc(p[3],fd);
  fputc(p[2],fd);
  fputc(p[1],fd);
  fputc(p[0],fd);
}


/* ================================================================== */


char Rhead[] =
	{ 'M','T','h','d',
	   0,0,0,6,		/* length */
	   0,1,			/* format */
	   0,3,			/* tracks */
	   0,TK_Q,		/* ticks per quarter */
	};

char Thead[] =
	{  0,0,0,26,		/* length */
	   0, 0xff,0x58, 4,
		4,2,		/* 4/4 */
		24,		/* MIDI clks/metronome unit */
		8,		/* 32th notes/24 MIDI clks */
#if (0)
	   0, 0xff,0x51, 3,	/* Set Tempo */
		7,0xa1,0x20,	/* quarter=500000 usec */
#endif
	   0, 0xff,0x59, 2,	/* Gmaj/Emin: force Finale to use #s */
		1,0
	};

char Shead[] =
	{ 'M','T','r','k' };


/*
  1 metronome pulse = 1 MIDI quarter = 24 MIDI clks
  1/4 equ 0.5" at resol.100 -> 1 tick=5*1000 usec
*/


void tempotrk(void)
{
  fwrite(Thead,1,sizeof(Thead),ftmp3);
}


void eotrk(FILE *fd)
{
  fputc(0,fd); fputc(0xff,fd); fputc(0x2f,fd); fputc(0,fd);
  fflush(fd);
}


void fappend(void)
{
 unsigned long k1,k2,k3;
 int n;

  k1=filelength(fileno(ftmp1));
  k2=filelength(fileno(ftmp2));
  k3=filelength(fileno(ftmp3));
  if (fseek(ftmp1,0,SEEK_SET)) return;
  if (fseek(ftmp2,0,SEEK_SET)) return;
  if (fseek(ftmp3,0,SEEK_SET)) return;

  fwrite(Shead,1,sizeof(Shead),fmpu);
  fiwrite(fmpu,&k3);
  while (k3) {
    n=fread(ebuf,1,4096,ftmp3);
    if (n<1) break;
    fwrite(ebuf,1,n,fmpu);
    k3-=n;
   }

  fwrite(Shead,1,sizeof(Shead),fmpu);
  fiwrite(fmpu,&k1);
  while (k1) {
    n=fread(ebuf,1,4096,ftmp1);
    if (n<1) break;
    fwrite(ebuf,1,n,fmpu);
    k1-=n;
   }

  fwrite(Shead,1,sizeof(Shead),fmpu);
  fiwrite(fmpu,&k2);
  while (k2) {
    n=fread(ebuf,1,4096,ftmp2);
    if (n<1) break;
    fwrite(ebuf,1,n,fmpu);
    k2-=n;
   }
}


/* ================================================================== */


void deltat(FILE *fd,unsigned long dt)
{
 unsigned long k;

  k=dt&0x7f;
  while ((dt>>=7)>0) {
    k<<=8;
    k|=0x80;
    k+=(dt&0x7f);
   }
  for (;;) {
    putc(k,fd);
    if (k&0x80) k>>=8; else break;
   }
}


int msout(void)
{
 char ch;

  ch=bioskey(0)&0xff;
  if (ch==27) return(1);
  if ((ch<' ')||(ch>126)) return(0);
  switch(ch) {
    case ' ': record = !record;
	      break;
    default:  while ((inportb(TheLink+3)&1)==0)
		if (bioskey(1)) { if ((bioskey(0)&0xff)==27) return(1); }
	      outportb(TheLink+1,ch);
	      putch('C');
	      return(0);
   }
  return(0);
}


unsigned long mserve(void)
{
 register int lks,lki;
 int i,first;
 long tf;
 unsigned char b,l,mpu;
 unsigned long k,t0a,t0b,t0t,t1;
 char buf[128];
 char *p;

  lki=TheLink; lks=TheLink+2;
  t0a=t0b=t0t=t1=0;
  tf=5000;			/* us per tick */
  first=1;

  for (;;) {
    p = (char *)(&t1);		/* absolute time in usec */
    for (i=0; i<4; i++) {
      while ((inportb(lks)&1)==0)
	if (bioskey(1)) { if (msout()) return(t1); }
      *p++ = inportb(lki);
     }

    while ((inportb(lks)&1)==0)
      if (bioskey(1)) { if (msout()) return(t1); }
    b=inportb(lki);

    l=b&31; mpu=(b&0x80); if (l==0) return(t1);
    nEv++;
    printf(record? "R":"*");

    for (i=0; i<l; i++) {		/* event data */
      while ((inportb(lks)&1)==0);
      buf[i] = inportb(lki);
     }

    if (player&&(*buf!=0xff)) {
      if (mpu) putdat2(*buf); else putdata(*buf);
      if (*buf==0xf0) i=2; else i=1;
      for (; i<l; i++) {
	if (mpu) putdat2(buf[i]); else putdata(buf[i]);
       }
     }

    if (*buf==0xff) {
      if (record) {
	if (first) {
	  t0a=t0b=t0t=t1; first=0;
	 }
	deltat(ftmp3,(t1-t0t)/tf);
	fwrite(buf,1,l,ftmp3);
	if (buf[1]==0x51) {
	  k=buf[3];
          k=(k<<8)|buf[4];
	  k=(k<<8)|buf[5];		/* k = quarter in usecs */
	  tf=k/100;
	  while (tf<5000) tf*=2;
	  while (tf>10000) tf/=2;
	  printf("[Q=%d]",(600000l/tf));
	 }
       }
      t0t=t1;
     }
    else {
      if (mpu) {
	if (record) {
	  deltat(ftmp2,(t1-t0b)/tf);
	  fwrite(buf,1,l,ftmp2);
	 }
	t0b=t1;
       }
      else {
	if (record) {
	  deltat(ftmp1,(t1-t0a)/tf);
	  fwrite(buf,1,l,ftmp1);
	 }
	t0a=t1;
       }
     }
   }
}


void noteend(void)
{
 static char noff[] = { 0,0xb0,0x7b,0 };
 int i;

  for (i=0; i<16; i++) {
    noff[1]=0xb0|i;
    fwrite(noff,1,4,ftmp1);
    fwrite(noff,1,4,ftmp2);
   }
}


/* ================================================================== */


void params(int argc,char *argv[])
{
 int i,j,v;
 float f;
 double d;
 char *p;

  record=0; player=1;
  j=0;

  for (i=0; i<8; i++) {
    if (argc<(i+3)) break;
    p = argv[i+2];
    if (*p=='/') {
      switch(toupper(p[1])) {
	case 'L': if (sscanf(p+2,"%x",&v)==1) {
		    if ((v==0x150)||(v==0x240)||(v==0x250))
		      TheLink=v;
		   }
		  break;
	case 'P': player=(p[2]!='-'); break;
	case 'R': record=(p[2]!='-'); break;
	default: break;
       }
     }
    else {
      if (isalpha(*p)) {
	strupr(p); f=0;
	if (!strcmp("PI",p)) f=3.14159265358979323846;
	 else if (!strcmp("SQ2",p)) f=1.41421356237309504880;
	  else if (!strcmp("E",p)) f=2.71828182845904523536;
	if (f!=0.0) {
	  memcpy((void *)&(HostPar[j]),(void *)&f,4);
	  j++;
	 }
       }
      else if (sscanf(argv[i+2],"%lf",&d)==1) {
	f=d;
	memcpy((void *)&(HostPar[j]),(void *)&f,4);
	j++;
       }
     }
   }
  HostPar[8]=1;
}


void main(int argc,char *argv[])
{
 char drive[MAXDRIVE];
 char dir[MAXDIR];
 char file[MAXFILE];
 char ext[MAXEXT];
 int flags;
 unsigned long t1;

  if (argc<2) { printf("No file\n"); exit(1); }
  flags=fnsplit(argv[1],drive,dir,file,ext);
  if (!(flags&EXTENSION)) strcpy(ext,".btl");
  fnmerge(Fn,drive,dir,file,ext);

  memset(HostPar,0,sizeof(HostPar));
  randomize();

  params(argc,argv);

  if (player) {
    all_notes_off(0);
    all_notes_off(1);
    delay(100);
    repeat_cmd401(0,UART);
    repeat_cmd401(1,UART);
   }

  if (!resetl(TheLink)) {
    printf("Hardware problem on link\n"); exit(1);
   }
  booting=1;
  if (net_boot(Fn,TheLink,0,0)==0) exit(1);

  fmpu =fopen("mpu.mid","wb");
  fwrite(Rhead,1,sizeof(Rhead),fmpu);
  fflush(fmpu);
  ftmp1=fopen("mpu.000","wb");
  ftmp2=fopen("mpu.001","wb");
  ftmp3=fopen("mpu.002","wb");

  tempotrk();

  sendhpar();

  nEv=0;
  if (bioskey(1)) getch();
  t1=mserve();
  noteend();

  eotrk(ftmp1);
  eotrk(ftmp2);
  eotrk(ftmp3);
  fclose(ftmp1);
  fclose(ftmp2);
  fclose(ftmp3);

  resetl(TheLink);

  if (player) {
    all_notes_off(0);
    all_notes_off(1);
   }

  ftmp1=fopen("mpu.000","rb");
  ftmp2=fopen("mpu.001","rb");
  ftmp3=fopen("mpu.002","rb");
  fappend();

  fcloseall();
  remove("mpu.000");
  remove("mpu.001");
  remove("mpu.002");

  printf("\n");

  printf("%d events received\n",nEv);
  exit(0);
}

/* ================================================================== */

