
/* ================================================================== */
/*			FRAME GENERATION UNIT                         */
/*			    version 001                               */
/* ================================================================== */

#include "mplay.h"
#include "../proteus.h"
#include "../canvas.h"
#include "../moc1.h"

/* ================================================================== */


int InstrSetup(void)
{
 char pn[4];
 int i,cchn,cmpu;
 TInstr *s;
 unsigned t0;

  pn[0]=pn[1]=pn[2]=pn[3]=0;

  asm { ldtimer; ldc 6; shl; ldc 10000; sum; st t0; }

/* PROTEUS (MPU 0,1) */

  for (i=0; i<32; i++) {
    s=&(InstrTab[i]);
    cmpu = (s->I.mpu & 3);
    cchn = (s->I.chan & 15) + (cmpu << 4);

    xparam(cmpu<<4,G_PPMAP+pn[cmpu],s->I.patch,t0);
    idenom(pn[cmpu]+(cmpu<<4),s->I.patch,t0);
    t0+=10; pn[cmpu]++;

  }

  for (i=0; i<32; i++) {
    s=&(InstrTab[i]);
    cmpu = (s->I.mpu & 3);
    cchn = (s->I.chan & 15) + (cmpu << 4);

    patch(cchn,s->I.chan,t0); t0+=5;
    volume(cchn,s->I.volume,t0); t0+=5;

    if (s->func!=NULL) {
      s->ws = calloc(1,2048); if (s->ws==NULL) return(0);
      _memcpy(s->ws,s->I.name,16);		/* debug */
      thread_start(s->func,s->ws,2048,1,1,i);
    }
  }
  asm { ldtimer; ldc 6; shl; ldc 10000; sum; st t0; }

/* MOC1+MSE1 (MPU 2) */

  for (i=32; i<47; i++) {
    s=&(InstrTab[i]);
    if (*(s->I.name)) {
      cmpu = (s->I.mpu & 3);
      cchn = (s->I.chan & 15) + (cmpu << 4);

      ocparam(cchn,s->I.patch,t0);
      idenom(pn[cmpu]+(cmpu<<4),(s->I.patch&127),t0);
      t0+=10; pn[cmpu]++;

      volume(cchn,s->I.volume,t0); t0+=5;

      if (s->func!=NULL) {
        s->ws = calloc(1,2048); if (s->ws==NULL) return(0);
        _memcpy(s->ws,s->I.name,16);		/* debug */
        thread_start(s->func,s->ws,2048,1,1,i);
      }
    }
  }
  asm { ldtimer; ldc 6; shl; ldc 10000; sum; st t0; }

/* CANVAS (MPU 3) */

  for (i=48; i<64; i++) {
    s=&(InstrTab[i]);
    if ((i!=57)&&(*(s->I.name))) {
      cmpu = (s->I.mpu & 3);
      cchn = (s->I.chan & 15) + (cmpu << 4);

      rcparam(cchn,(s->I.patch-1)&127,(s->I.patch>>8),t0);
      idenom(pn[cmpu]+(cmpu<<4),(s->I.patch&127),t0);
      t0+=10; pn[cmpu]++;

      volume(cchn,s->I.volume,t0); t0+=5;

      if (s->func!=NULL) {
        s->ws = calloc(1,2048); if (s->ws==NULL) return(0);
        _memcpy(s->ws,s->I.name,16);		/* debug */
        thread_start(s->func,s->ws,2048,1,1,i);
      }
    }
  }

  asm { ldtimer; ldc 1000; sum; tin; }

  return(1);
}


/* ================================================================== */

