
/* ================================================================== */
/*			PLAYER ENGINE for Tx                          */
/*			  by Harawi 8/3/93                            */
/* ================================================================== */

#include "mplay.h"

#define SLOTS	1024

#define GETSLOT(x)	while(FreeQ==EndQ);x=FreeQ;FreeQ=x->next;nFree--

EVENT *EvArray;
EVENT *FreeQ,*EndQ;		/* free list */
int   nFree;
EVENT *ExQueue,*EndXQ;		/* exec list */
int   IsPlay;
CHAN  EvCh;
unsigned Btempo,TimeD;
int   MIDmode,Debug;
static int plCtl = 0;

char Playws[256];		/* workspace for player process */
char GHws[128];

_paramblk Params;

TInstr InstrTab[VOICES];

#ifdef NCHECK
static unsigned char nOnTab[64*128];
#endif

#ifdef DTC2
#define HostCmd		*((char *)0x400800)
#else
int   HostCmd;
#endif

char  EMUparmask[] =
	{ 15,0xf0,13,0x18,4,0,3,
/*07*/	  0,2,0,0,
/*0b*/	  3,2,0,0,
/*0f*/	  0xf7 };

char  SCparmask[] =
	{ 8,
	  0xb0,0,0,
	  0xb0,32,0,
	  0xc0,0 };

#define PMK1	6
#define PMK2	10

/* =================================================================== */
/*
	EVENT PROCESS: STACK FRAME
	Ŀ
       0Ĵ-14 W[-15]=next ptr
		      -13 W[-14]=flags
       1Ĵ-12 W[-13]=data( 0.. 3)
       2Ĵ-11 W[-12]=data( 4.. 7)
       3Ĵ-10 W[-11]=data( 8..11)
       4Ĵ -9 W[-10]=data(12..15)
       5Ĵ -8 W[ -9]=data(16..19)
       6Ĵ -7 W[ -8]=data(20..23)
       7Ĵ -6 W[ -7]=data(24..27)
       8Ĵ -5 W[ -6]	(timer use)
       9Ĵ -4 W[ -5]
      10Ĵ -3 W[ -4]
      11Ĵ -2 W[ -3]
      12Ĵ -1 W[ -2]
      13Ĵ  0 W[ -1]=Iptr  ----> W[0]
      14Ĵ  1 W[  0]=RA
      15Ĵ  2 W[  1]=SL
      16Ĵ  3 W[  2]=time
      17Ĵ  4 W[  3]=&EvQueue
      18Ĵ  5 W[  4]=&EndXQ
      19Ĵ  6 W[  5]=&EvCh;
      20
 */

#define P_NEXT -14
#define P_TIME	3
#define P_EXQU  4
#define P_ENDXQ 5
#define P_EVCH  6


void evplay(void)
{
  asm { ajw -1; }
/* -- wait on hi-pri timer -- */
  asm { ldl P_TIME; tin; }

/* -- put element on execution list -- */
/*  if (ExQueue==NULL) ExQueue=p;
     else EndXQ->next=p;
    EndXQ=p;	*/

  asm { ldl P_EXQU; ldnl 0; cj W21;
	ldlp P_NEXT; ldl P_ENDXQ; ldnl 0; stnl 0; j W22; }
W21:
  asm { ldlp P_NEXT; ldl P_EXQU; stnl 0; }
W22:
  asm { ldlp P_NEXT; ldl P_ENDXQ; stnl 0;
	ldc 0; stl P_NEXT; }

/* -- notify execution process if not active -- */
  asm { ldl P_EVCH; ldnl 0; mint; xor; cj W23;
	ldl P_EVCH; ldc 1; outbyte; }
W23:
  asm {	stopp; }
}


/* =================================================================== */
/*
	GENERAL STACK FRAME
	Ŀ
	            
	Ĵ
	Ĵ
	ĴW[-1]=Iptr for runp
	ĴW[0]=return address    |call|
	ĴW[1]=Areg=static chain |    |
	ĴW[2]=Breg=1st param    |    |
	ĴW[3]=Creg=2nd param    |    |
	ĴW[4+]=other params          |W[0]ret
	
 */
static char *_Thread_Start(void (*)(),char *,int,int,int *);
static void _ThreadGo(int *,int);


void _ThreadStart(void (*fn)(),char *ws,int wssize,int flags,
		int nargs, ...)
{
  _Thread_Start(fn,ws,wssize,flags,&nargs);
}


static void _ThreadStop(void)
{
  asm { ldl -3;	stl 1; }	/* save GSB static chain */
  asm {	stopp; }
}

static char *_Thread_Start(void (*fn)(),char *ws,int wssize,
		int flags,int *alist)
{
 int n,nw;
 int *ap,*Wptr;

  ap=alist; alist++;		/* 'alist' points to 1st arg */
  n = *ap;			/* 'n' is n.of args */

  while (((int)ws&(WORDSIZE-1))!=0) {	/* align workspace */
    ws++; wssize--;
   }
  wssize >>= WORDSHIFT;		/* wssize was in bytes */
  nw = n;
  if (nw<2) nw=2;		/* at least 2 argument slots */

  Wptr = (((int *)ws+wssize)-nw)-2;
  Wptr[-1] = (int)(fn);
  Wptr[0]  = (int)_ThreadStop;
  ap=Wptr+2;			/* ap = parameters on stack */
  while (n--) {
    *ap++=*alist++;
   }
  _ThreadGo(Wptr,(flags&1));
  return(ws);
}


static void _ThreadGo(int *ws,int prior)
{
  asm { ldl 1; st ws[1]; }	/* save static chain at W[1] */
  asm { ld ws; ld prior; or; runp; }
}


static void _EventStop(void)
{
  asm { ldl -3;	stl 1; }	/* save GSB static chain */
  asm {	stopp; }
}


static void Event_Start(EVENT *E,unsigned t)
{
 int *Wptr;

  if (Debug) return;
  Wptr = &(E->frame[6]);
  Wptr[-1] = (int)(evplay);
  Wptr[ 2] = t;			/* time of event */
  _ThreadGo(Wptr,0);
}


/* ================================================================== */
/*		   LOW PRIORITY event generators                      */
/* ================================================================== */


unsigned EOS (unsigned t)
{
 EVENT *E;

  GETSLOT(E);
  E->data[0]=0;
  E->flags = 0;
  Event_Start(E,t);
  return(t+BYTETIME);
}


unsigned ntempo (unsigned nt,unsigned t)
{
 static char ntk[] = { 6,0xff,0x51,3,0,0,0 };
 EVENT *E;

  if (MIDmode) {
    GETSLOT(E);
    _memcpy(E->data,ntk,7);
    nt *= QUARTER;
    E->data[6]=nt&0xff; nt>>=8;
    E->data[5]=nt&0xff; nt>>=8;
    E->data[4]=nt&0xff;
    E->flags = 0;
    Event_Start(E,t);
   }
  return(t+BYTETIME);
}


unsigned idenom (int chan,int num,unsigned t)
{
 static char ntk[] = { 9,0xff,1,6,0,0,'=',0,0,0 };
 EVENT *E;

  if (MIDmode) {
    GETSLOT(E);
    _memcpy(E->data,ntk,10);
    E->data[5]=(chan%10)+'0'; chan/=10;
    E->data[4]=(chan&7)+'0';
    E->data[9]=(num%10)+'0'; num/=10;
    E->data[8]=(num%10)+'0'; num/=10;
    E->data[7]=num+'0';
    E->flags = 0;
    Event_Start(E,t);
   }
  return(t+BYTETIME);
}


unsigned oevent (int p1,int p2,unsigned t)
{
 static char ntk[] = { 11,0xff,6,8,0,0,0,0,0,0,0,0 };
 EVENT *E;

  if (MIDmode) {
    GETSLOT(E);
    _memcpy(E->data,ntk,4);
    _memcpy(E->data+4,&p1,4);
    _memcpy(E->data+8,&p2,4);
    E->flags = 0;
    Event_Start(E,t);
   }
  return(t+BYTETIME);
}


unsigned mevent (char *p1,int p2,unsigned t)
{
 static char ntk[] = { 15,0xff,6,12, 0,0,0,0,0,0,0,0, 0,0,0,0 };
 char *q;
 int i;
 EVENT *E;

  if (MIDmode) {
    GETSLOT(E);
    _memcpy(E->data,ntk,12);
    q=E->data+4;
    for (i=0; ((i<7) && *p1); i++) *q++ = *p1++;
    E->data[11] = 0;
    _memcpy(E->data+12,&p2,4);
    E->flags = 0;
    Event_Start(E,t);
   }
  return(t+BYTETIME);
}


unsigned noteon (int chan,int h,int v,unsigned t)
{
 EVENT *E;
 int mpu,ix;

  chan &= 0x3f; h &= 0x7f;
  ix = (chan<<7)+h;
  mpu=C2MPU(chan); chan&=15;

  GETSLOT(E);
  E->data[0]=mpu|3;
  E->data[1]=NOTE_ON|chan;
  E->data[2]=h;
  E->data[3]=v;
  *((int *)(E->data+4)) = ix;
  E->flags = 0;
  Event_Start(E,t);
  plCtl=1;
  return(t+BYTETIME);
}


unsigned allnoteoff (int chan,unsigned t)
{
 EVENT *E;
 int mpu;

  if (plCtl) {
    mpu=C2MPU(chan); chan&=15;

    GETSLOT(E);
    E->data[0]=mpu|3;
    E->data[1]=0xb0|chan;
    E->data[2]=0x7b;
    E->data[3]=0;
    E->flags = 0;
    Event_Start(E,t);
  }
  return(t+BYTETIME);
}


unsigned noteoff (int chan,int h,int v,unsigned t)
{
 EVENT *E;
 int mpu,ix;

  chan &= 0x3f; h &= 0x7f;
  ix = (chan<<7)+h;
  mpu=C2MPU(chan); chan&=15;

  GETSLOT(E);
  E->data[0]=mpu|3;
  E->data[1]=NOTE_OFF|chan;
  E->data[2]=h;
#ifdef OFFVOL
  E->data[3]=v & 0x7f;
#else
  E->data[3]=0;
#endif
  *((int *)(E->data+4)) = ix;
  E->flags = 0;
  Event_Start(E,t);
  return(t+BYTETIME);
}


unsigned volume (int chan,int v,unsigned t)
{
 EVENT *E;
 int mpu;

  if (nFree<2) return(t);	/* do not wait if Q full */
  mpu=C2MPU(chan); chan&=15;

  GETSLOT(E);
  E->data[0]=mpu|3;
  E->data[1]=0xb0|chan;
  E->data[2]=7;
  E->data[3]=v&0x7f;
  E->flags = 0;
  Event_Start(E,t);
  return(t+BYTETIME);
}


unsigned patch (int chan,int n,unsigned t)
{
 EVENT *E;
 int mpu;

  mpu=C2MPU(chan); chan&=15;

  GETSLOT(E);
  E->data[0]=mpu|2;
  E->data[1]=0xc0|chan;
  E->data[2]=n;
  E->flags = 0;
  Event_Start(E,t);
  return(t+BYTETIME);
}


unsigned pressure (int chan,int v,unsigned t)
{
 EVENT *E;
 int mpu;

  if (nFree<2) return(t);	/* do not wait if Q full */
  mpu=C2MPU(chan); chan&=15;

  GETSLOT(E);
  E->data[0]=mpu|2;
  E->data[1]=0xd0|chan;
  E->data[2]=v;
  E->flags = 0;
  Event_Start(E,t);
  return(t+BYTETIME);
}


unsigned chknote (NoteEvent *N,unsigned t)
{
  return (t +((N->deltat*TimeD)& 0xffffff));
}


unsigned note (NoteEvent *N,unsigned t)
{
 EVENT *E;
 int chan,mpu,ix;
 unsigned ndc,ndt;

  if (nFree<3) return(t);	/* do not wait if Q full */
  if ((int)N->duration < 10) return(t);
  ix = ((N->timbre&0x3f)<<7) + (N->pitch&0x7f);
#ifdef NCHECK
  if (nOnTab[ix]>=2) return(t);
#endif

  mpu=C2MPU(N->timbre);
  chan=N->timbre&15;
  ndc=(N->duration*TimeD) & 0x7fffff;
  ndt=(N->deltat*TimeD) & 0xffffff;
#ifndef COMPAT
  if (ndc>ndt) ndc=ndt-10;
#endif

  if (Debug) {
    N->a=t;
    N->b=t+ndc;
    N->c=t+ndt;
    asm { mint;
#ifdef DTC3
	  ldnlp 1;
#endif
    	  ldc NEVSIZE; ajw -1; outbyte; ajw 1; }
    asm { ld N; mint;
#ifdef DTC3
	  ldnlp 1;
#endif
    	  ldc NEVSIZE; out; }
   }
  else {
    GETSLOT(E);
    E->data[0]=mpu|3;
    E->data[1]=NOTE_ON|chan;
    E->data[2]=N->pitch & 0x7f;
    E->data[3]=N->intensity & 0x7f;
    *((int *)(E->data+4)) = ix;
    E->flags = 0;
    plCtl=1;
    Event_Start(E,t);

    GETSLOT(E);
    E->data[0]=mpu|3;
    E->data[1]=NOTE_OFF|chan;
    E->data[2]=N->pitch & 0x7f;
#ifdef OFFVOL
    E->data[3]=N->intensity & 0x7f;
#else
    E->data[3]=0;
#endif
    *((int *)(E->data+4)) = ix;
    E->flags = N->lock;
    Event_Start(E,t+ndc);
   }

  return(t+ndt);
}


unsigned repnote (NoteEvent *N, unsigned iT, int dT, unsigned t)
{
 EVENT *E;
 int chan,mpu,ix;
 unsigned ndc,ndt;

  if (nFree<3) return(t);	/* do not wait if Q full */
  if ((int)N->duration < 10) return(t);
  ix = ((N->timbre&0x3f)<<7) + (N->pitch&0x7f);
#ifdef NCHECK
  if (nOnTab[ix]>=2) return(t);
#endif

  mpu=C2MPU(N->timbre);
  chan=N->timbre&15;
  ndc = t + ((N->duration*TimeD) & 0x7fffff);
  ndt = t + ((N->deltat*TimeD) & 0xffffff);

  if (Debug) {
    N->a=t;
    N->b=ndc;
    N->c=ndt;
    asm { mint;
#ifdef DTC3
	  ldnlp 1;
#endif
    	  ldc NEVSIZE; ajw -1; outbyte; ajw 1; }
    asm { ld N; mint;
#ifdef DTC3
	  ldnlp 1;
#endif
    	  ldc NEVSIZE; out; }
   }
  else {
    while (t < ndc) {
      GETSLOT(E);
      E->data[0]=mpu|3;
      E->data[1]=NOTE_ON|chan;
      E->data[2]=N->pitch & 0x7f;
      E->data[3]=N->intensity & 0x7f;
      *((int *)(E->data+4)) = ix;
      E->flags = 0;
      plCtl=1;
      Event_Start(E,t);

      GETSLOT(E);
      E->data[0]=mpu|3;
      E->data[1]=NOTE_OFF|chan;
      E->data[2]=N->pitch & 0x7f;
#ifdef OFFVOL
      E->data[3]=N->intensity & 0x7f;
#else
      E->data[3]=0;
#endif
      *((int *)(E->data+4)) = ix;
      E->flags = N->lock;
      Event_Start(E,t+((iT>>2)*3));
      
      t += iT;
      iT += dT; if (iT<20000) break;
      if (nFree<3) break;
     }
   }

  return(ndt);
}


unsigned fullnote (NoteEvent *N,unsigned t)
{
 EVENT *E;
 int i,chan,mpu,vf,pf,ix;
 unsigned ndc,ndt;
 unsigned tp;

  if (nFree<16) return(t);	/* do not wait if Q full */
  if ((int)N->duration < 10) return(t);
  ix = ((N->timbre&0x3f)<<7) + (N->pitch&0x7f);
#ifdef NCHECK
  if (nOnTab[ix]>=2) return(t);
#endif

  mpu=C2MPU(N->timbre);
  chan=N->timbre&15;

  ndc=(N->duration*TimeD) & 0x7fffff;
  ndt=(N->deltat*TimeD) & 0xffffff;
#ifndef COMPAT
  if (ndc>ndt) ndc=ndt-10;
#endif

  if (Debug) {
    N->a=t;
    N->b=t+ndc;
    N->c=t+ndt;
    asm { mint;
#ifdef DTC3
	  ldnlp 1;
#endif
    	  ldc NEVSIZE; ajw -1; outbyte; ajw 1; }
    asm { ld N; mint;
#ifdef DTC3
	  ldnlp 1;
#endif
    	  ldc NEVSIZE; out; }
   }
  else {
    vf=N->startvol&0x7f; pf=N->startpress&0x7f;
    tp=t;
    if (vf) {
	GETSLOT(E);
	E->data[0]=mpu|3;
	E->data[1]=0xb0|chan;
	E->data[2]=7;
	E->data[3]=vf;
        E->flags = 0;
	Event_Start(E,t-2);
     }
    if (pf) {
	GETSLOT(E);
	E->data[0]=mpu|2;
	E->data[1]=0xd0|chan;
	E->data[2]=pf;
        E->flags = 0;
	Event_Start(E,t-1);
     }
    plCtl=1;

    GETSLOT(E);
    E->data[0]=mpu|3;
    E->data[1]=NOTE_ON|chan;
    E->data[2]=N->pitch & 0x7f;
    E->data[3]=N->intensity & 0x7f;
    *((int *)(E->data+4)) = ix;
    E->flags = 0;
    Event_Start(E,t);

    for (i=0; i<3; i++) {
      tp += (ndc>>2);
      if (vf && N->deltavol) {
	vf += N->deltavol;
	if (vf<0) vf=0; else {
	  if (vf>127) vf=127;
	  GETSLOT(E);
	  E->data[0]=mpu|3;
	  E->data[1]=0xb0|chan;
	  E->data[2]=7;
	  E->data[3]=vf;
          E->flags = 0;
	  Event_Start(E,tp);
	 }
       }
      if (pf && N->deltapress) {
	pf += N->deltapress;
	if (pf<0) pf=0; else {
	  if (pf>127) pf=127;
	  GETSLOT(E);
	  E->data[0]=mpu|2;
	  E->data[1]=0xd0|chan;
	  E->data[2]=pf;
          E->flags = 0;
	  Event_Start(E,tp+1);
	 }
       }
     }

    GETSLOT(E);
    E->data[0]=mpu|3;
    E->data[1]=NOTE_OFF|chan;
    E->data[2]=N->pitch & 0x7f;
#ifdef OFFVOL
    E->data[3]=N->intensity & 0x7f;
#else
    E->data[3]=0;
#endif
    *((int *)(E->data+4)) = ix;
    E->flags = N->lock;
    Event_Start(E,t+ndc);
   }

  return(t+ndt);
}


unsigned pedal (NoteEvent *N,unsigned t)
{
 EVENT *E;
 int chan,mpu;

  mpu=C2MPU(N->timbre); chan=N->timbre&15;

  GETSLOT(E);
  E->data[0]=mpu|3;
  E->data[1]=MODE_MESSAGE|chan;
  E->data[2]=64;
  E->data[3]=127;
  E->flags = 0;
  Event_Start(E,t);

  GETSLOT(E);
  E->data[0]=mpu|3;
  E->data[1]=MODE_MESSAGE|chan;
  E->data[2]=64;
  E->data[3]=0;
  E->flags = 0;
  Event_Start(E,t+N->duration*TimeD);

  return(t);
}


unsigned xparam (int chan,int n,int v,unsigned t)
{
 EVENT *E;
 int l,mpu;

  mpu=C2MPU(chan);
  GETSLOT(E);

  l=sizeof(EMUparmask);
  _memcpy(E->data,EMUparmask,l);
  E->data[0] |= mpu;
  E->data[PMK1+3] = chan&15;
  E->data[PMK2+1] = n&0x7f;
  E->data[PMK2+2] = (n>>7)&0x7f;
  E->data[PMK2+3] = v&0x7f;
  E->data[PMK2+4] = (v>>7)&0x7f;
  E->flags = 0;
  Event_Start(E,t);

  return(t+l*BYTETIME);
}


unsigned ocparam (int chan,int n,unsigned t)
{
 EVENT *E;
 int l,mpu;

  mpu=C2MPU(chan);
  GETSLOT(E);

  l=sizeof(SCparmask);
  _memcpy(E->data,SCparmask,l);
  E->data[0] |= mpu;
  E->data[1] = E->data[4] = 0xb0|(chan&15);
  E->data[7] = 0xc0|(chan&15);
  E->data[3] = ((n>>8)&1) + 80;
  E->data[8] = (n-1)&127;
  E->flags = 0;
  Event_Start(E,t);

  return(t+l*BYTETIME);
}


unsigned rcparam (int chan,int n,int v,unsigned t)
{
 EVENT *E;
 int l,mpu;

  if ((v==0) && ((chan&15)!=10))
    return patch (chan,n,t);
  else {
    mpu=C2MPU(chan);
    GETSLOT(E);

    l=sizeof(SCparmask);
    _memcpy(E->data,SCparmask,l);
    E->data[0] |= mpu;
    E->data[1] = E->data[4] = 0xb0|(chan&15);
    E->data[7] = 0xc0|(chan&15);
    E->data[3] = v;
    E->data[8] = n;
    E->flags = 0;
    Event_Start(E,t);

    return(t+l*BYTETIME);
  }
}


unsigned nothing (NoteEvent *N,unsigned t)
{
  return(t+(N->deltat*TimeD));
}


/* ================================================================== */
/*		      HIGH PRIORITY player process                    */
/* ================================================================== */


void PlayLoop(void)
{
 EVENT *E;
 int l;
 unsigned tE;
#ifdef DTC2
 int i, w;
 unsigned uab;
#endif

  IsPlay=1;

  while (IsPlay) {
/* wait until at least 1 event in exec queue */
    asm { ld &l; ld &EvCh; ldc 1; in; }

/* process events in exec queue */
    while (IsPlay && ((E=ExQueue)!=NULL)) {

#ifdef NCHECK
      if ((E->data[1]&0xf0)==NOTE_ON) {		/* note on */
        int ix = *((int *)(E->data+4));
        if (nOnTab[ix]>=2) goto next;
        nOnTab[ix] += 1;
      }
      else if ((E->data[1]&0xf0)==NOTE_OFF) {	/* note off */
        int ix = *((int *)(E->data+4));
        if (nOnTab[ix]>0) nOnTab[ix] -= 1;
      }
#endif
      tE = E->param[0];

/* send event data to host */
      l = (E->data[0]&31)+1;
      if (MIDmode) E->data[0] |= MIDIBIT;
/* ----------------------------------------------------------------------- */
#ifdef DTC2
/* Remember that T-addresses are word aligned - we must move the MPU bit(s)
   to bits 1-2 -> <<2 = bits 3-4 */
#if VOICES<=32
/* NOT mpu bit 7 (why?) to bit 3 */
      uab = UARTBASE + ((E->data[0]&0x80)>>4);
#else
/* mpu bits 6-7 to bits 3-4 */
      uab = UARTBASE + ((E->data[0]&0xC0)>>3);
#endif
      if (MIDmode) asm { ld E->data; mint;
      			 ld l; out; }
      if (E->data[1] != 0xff) {
        i=1;
        w=0;
        if (E->data[1] == 0xf0) {
          do { asm { ldtimer; ldc 160; sum; tin; } }
            while (*((char *)(uab+4))&1);
          *((char *)uab) = 0xf0;
          *((char *)(uab+4)) = 1;
          i=3;		/* skip extra length byte */
          w=1;
        }
        for (; i<l; i++) {
          do { asm { ldtimer; ldc 160; sum; tin; } }
            while (*((char *)(uab+4))&1);
          *((char *)uab) = E->data[i];
          *((char *)(uab+4)) = 1;
          if (w) { asm { ldtimer; ldc 500; sum; tin; } }
        }
      }
#else
/* ----------------------------------------------------------------------- */
      asm { ld E->data; mint;
#ifdef DTC3
	    ldnlp 1;
#endif
      	    ld l; out; }
#endif
/* ----------------------------------------------------------------------- */
      if (MIDmode) {		/* MID file: output time in usec */
	asm { ld &tE; mint;
#ifdef DTC3
	      ldnlp 1;
#endif
	      ldc 4; out; }
       }
      if (l==1) IsPlay=0;

/* detach event from exec queue, put it on tail of free list */
next:
      ExQueue = E->next;
      E->next=NULL;
      EndQ->next=E;
      EndQ=E;
      nFree++;
     }
   }
}


#ifndef DTC2
void GetHost(void)
{
 char k;

  for (;;) {
    asm { ld &k; mint;
#ifdef DTC3
	  ldnlp 5;
#else
	  ldnlp 4;
#endif
    	  ldc 1; in; }
    if (HostCmd==0) HostCmd=k;
   }
}
#endif


/* =================================================================== */


int EvAlloc(int n)
{
 int i;
 EVENT *p;

  if ((EvArray=(EVENT *)calloc(n,sizeof(EVENT)))==NULL) return(0);

  for (i=0; i<n; i++) {
    p = &(EvArray[i]);
    p->next = p+1;
    p->frame[6] = (int)_EventStop;
    p->param[1] = (int)(&ExQueue);
    p->param[2] = (int)(&EndXQ);
    p->param[3] = (int)(&EvCh);
   }
  FreeQ = EvArray;
  EndQ = &(EvArray[n-1]);
  EndQ->next=NULL;
  nFree = n;
  ExQueue = NULL;
  EndXQ = NULL;
  asm { mint; st EvCh; }
  TimeD = Btempo;

  return(1);
}


/* ================================================================== */


int main(void)
{
 int i, k;

/* get parameters from host (4032 bytes) */
  asm { ld &Params;
	mint;
#ifdef DTC3
	ldnlp 5;
	ldc 4032;
#else
	ldnlp 4;
	ldc sizeof(Params);
#endif
	in; }

  for (i=0; i<VOICES; i++) {
    InstrTab[i].I = Params.instr[i];
    InstrTab[i].ichan = NOCHAN;
    InstrTab[i].func = NULL;
    InstrTab[i].ws = NULL;
   }
#ifdef NCHECK
  memset(nOnTab,0,64*128);
#endif

/* use host random delay to initialize standard random generator */
  asm { ldtimer; st k; }
  srand(k);
  Srand(k);

  k = Params.xp[0];
  MIDmode = ((k&1)==1);
  Debug = ((k&2)==2);

  Btempo = 1000;		/* msec->usec conversion */
  HostCmd = 0;
/*------------------------------------*/
/**/  InitGen();  /*-- user-defined --*/
/*------------------------------------*/

  if (EvAlloc(SLOTS)) {

    asm { ldc 0; sttimer; }

    _ThreadStart(PlayLoop,Playws,256,0,0);

    asm { ld &k; mint;
#ifdef DTC3
	  ldnlp 5;
#else
	  ldnlp 4;
#endif
    	  ldc 1; in; }

#ifndef DTC2
    _ThreadStart(GetHost,GHws,128,0,0);
#endif
    if (InstrSetup()) {
/*--------------------------------------*/
/**/    GenLoop();  /*-- user-defined --*/
/*--------------------------------------*/
     }
    while (IsPlay&&(nFree<SLOTS));
   }
  asm { ajw -1; mint;
#ifdef DTC3
	ldnlp 1;
#endif
  	ldc 0;
  	outbyte; ajw 1; }
  for (;;);
}


/* ================================================================== */

